// IirFilterView.cpp : CIirFilterView NX̓̒`s܂B
// by Toshio Iwata at digitalfilter.com 2004/09/16

#include "stdafx.h"
#include "IirFilter.h"

#include "IirFilterDoc.h"
#include "IirFilterView.h"
#include "DlgDisp.h"
#include "DlgRng.h"
#include "DlgFs.h"
#include "DlgWrErr.h"

#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CIirFilterView

IMPLEMENT_DYNCREATE(CIirFilterView, CView)

BEGIN_MESSAGE_MAP(CIirFilterView, CView)
	//{{AFX_MSG_MAP(CIirFilterView)
	ON_COMMAND(ID_MENU_COLD, OnMenuCold)
	ON_COMMAND(ID_MENU_DISP, OnMenuDisp)
	ON_COMMAND(ID_MENU_FS, OnMenuFs)
	ON_COMMAND(ID_MENU_RNG, OnMenuRng)
	ON_COMMAND(ID_MENU_WVLD, OnMenuWvld)
	ON_COMMAND(ID_MENU_WVSV, OnMenuWvsv)
	//}}AFX_MSG_MAP
	// WR}h
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIirFilterView NX̍\z/

CIirFilterView::CIirFilterView()
{
	// TODO: ̏ꏊɍ\zp̃R[hǉĂB
	BiquadN = 2;
	Pi = 3.14159;
	Fsamp = 22050;
	gain_range = 100.0;
	gain_offset = 0.0;
	freq_range = Fsamp/2.0;
	filecoeffld = "coeff0.txt";
	coeff_loaded = FALSE;
	wave_loaded = FALSE;
	view_select = 0;
	coeff_range = 1.0;
	mono1_stereo2 = 1;
	samplingfreq = 22050;
	bitlength = 8;
	totalbytes = 22050;
	bytesinfile = 22050;
	chbytes_per_sample = 1;
	bytes_per_sample = 1;
	bytes_per_sec = 22050;
	wavesize = 22050;
	timelength = 1;
	dotn = 500;
	allocated = FALSE;
	xstep = 1;
	yframe = 100;
	yrng = 10000;
	xstart = 0;
	allocated2 = FALSE;
}

CIirFilterView::~CIirFilterView()
{
}

BOOL CIirFilterView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CIirFilterView NX̕`

void CIirFilterView::OnDraw(CDC* pDC)
{
	CIirFilterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B
	if(coeff_loaded) {

		IirFresCal(Gain, Theta);
		if(wave_loaded) IirOutWaveCal();

		if(view_select == 0) FresDraw(pDC, 100, 60, Gain, Theta);
		else if(view_select == 1) IirCoeffDraw(pDC, 60, 60);
		else if(wave_loaded) {
			pDC->TextOut( 280, 70, "Input Wave");
			WaveDraw(pDC, 80, 160, InWave);
			pDC->TextOut( 280, 320, "Output Wave");
			WaveDraw(pDC, 80, 410, OutWave);
		} else {
			pDC->TextOut( 50, 110, "uWavet@CvuWaveݍ݁vIĂB");
		}
	} else {
		pDC->TextOut( 50, 50, "IirFilter.exe");
		pDC->TextOut( 50, 80, "IIRtB^̌Wǂݍŕ`悵܂B");
		pDC->TextOut( 50, 110, "uIIRtB^vuWǂݍ݁vIĂB");
		pDC->TextOut( 50, 140, "by DIGITALFILTER.COM");
	}
}

/////////////////////////////////////////////////////////////////////////////
// CIirFilterView NẌ

BOOL CIirFilterView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// ftHg̈
	return DoPreparePrinting(pInfo);
}

void CIirFilterView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: O̓ʂȏǉĂB
}

void CIirFilterView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: ̌㏈ǉĂB
}

/////////////////////////////////////////////////////////////////////////////
// CIirFilterView NX̐ff

#ifdef _DEBUG
void CIirFilterView::AssertValid() const
{
	CView::AssertValid();
}

void CIirFilterView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CIirFilterDoc* CIirFilterView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CIirFilterDoc)));
	return (CIirFilterDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CIirFilterView NX̃bZ[W nh

void CIirFilterView::FresDraw(CDC *pDC, int x0, int y0, double *Xg, double *Xt)
{
	double start_fr, end_fr, mid_fr;
	double tmp_xfr[400], tmp_xth[400];
	int	i;
	char freq_char[15];
	char gain_char[15];
	double xstep = 2.0;

	CPen	myPen;
	CPen*	pOldPen;

	for (i = 0; i < 400; i++) tmp_xfr[i] = 0.0;

	pDC->TextOut(x0 + 360 - 10, y0 - 28,"Phase [rad]");
	pDC->TextOut(x0 + 360 + 10, y0 + 52,"  pi ");
	pDC->TextOut(x0 + 360 + 10, y0 + 92," pi/2");
	pDC->TextOut(x0 + 360 + 10, y0 + 132,"   0 ");
	pDC->TextOut(x0 + 360 + 10, y0 + 172,"-pi/2");
	pDC->TextOut(x0 + 360 + 10, y0 + 212," -pi ");

	start_fr = 0.0;
	end_fr = start_fr + freq_range / 1.0;
	mid_fr = start_fr + freq_range / 2.0;

	sprintf(freq_char,"%10.3f", start_fr);
	pDC->TextOut(x0 - 50, y0 + 250, freq_char);
	sprintf(freq_char,"%10.3f", mid_fr);
	pDC->TextOut(x0 - 10 + 150, y0 + 250, freq_char);
	sprintf(freq_char,"%10.3f", end_fr);
	pDC->TextOut(x0 - 10 + 330, y0 + 250, freq_char);
	pDC->TextOut(x0 - 10 + 410, y0 + 250,"[Hz]");

	myPen.CreatePen(PS_DOT, 1, RGB(100,100,100));
	pOldPen = pDC->SelectObject(&myPen);

	for(i = 0; i <= 12; i++) {
		pDC->MoveTo(x0      , y0 + i * 20);
		pDC->LineTo(x0 + 360, y0 + i * 20);
	}

	for(i = 0; i <= 10; i++) {
		pDC->MoveTo(x0 + i * (360 / 10), y0);
		pDC->LineTo(x0 + i * (360 / 10), y0 + 240);
	}

	pDC->SelectObject(pOldPen);
	myPen.DeleteObject();

	myPen.CreatePen(PS_DOT, 1, RGB(50,50,50));
	pOldPen = pDC->SelectObject(&myPen);

	pDC->MoveTo(x0      , y0 + 2 * 20);
	pDC->LineTo(x0 + 360, y0 + 2 * 20);

	pDC->MoveTo(x0 + 5 * (360 / 10), y0);
	pDC->LineTo(x0 + 5 * (360 / 10), y0 + 240);

	pDC->SelectObject(pOldPen);
	myPen.DeleteObject();

	// Frame drawing
	for(i = 0; i <= 12; i = i + 12) {
		pDC->MoveTo(x0      , y0 + i * 20);
		pDC->LineTo(x0 + 360, y0 + i * 20);
	}
	for(i = 0; i <= 10; i = i + 10) {
		pDC->MoveTo(x0 + i * (360 / 10), y0);
		pDC->LineTo(x0 + i * (360 / 10), y0 + 240);
	}

	myPen.CreatePen(PS_SOLID, 1, RGB(0,255,0));
	pOldPen = pDC->SelectObject(&myPen);
	
	for(i = 0; i < 180; i++) {
    	tmp_xth[i] = 25.5 * Xt[i];
		if( tmp_xth[i] < -100 ) tmp_xth[i] = -100;
		if( tmp_xth[i] > 140 ) tmp_xth[i] = 140;
	}

	xstep = Fsamp/freq_range;

	for(i = 0; i < 179; i++) {
		if( (i+1)*xstep < 360 ) {
			pDC->MoveTo(x0 + (int)(i*xstep), y0 + 140 - (int)(tmp_xth[i]));
			pDC->LineTo(x0 + (int)((i+1)*xstep), y0 + 140 - (int)(tmp_xth[i + 1]));
		}
	}
	
	pDC->TextOut(x0 + 200, y0 - 40,"Phase");
   	pDC->MoveTo(x0 + 250, y0 - 30);
	pDC->LineTo(x0 + 270, y0 - 30);

	pDC->SelectObject(pOldPen);
	myPen.DeleteObject();

	myPen.CreatePen(PS_SOLID, 1, RGB(255, 0, 0));
	pOldPen = pDC->SelectObject(&myPen);

	double ymax, ymin, yrange;

	ymax = 40.0;
	ymin = -200.0;
	yrange = 2.0 * 100.0 / gain_range;

	for(i = 0; i < 180; i++) {
    	tmp_xfr[i] = yrange * (Xg[i] - gain_offset);
		if( tmp_xfr[i] < ymin ) tmp_xfr[i] = ymin;
		if( tmp_xfr[i] > ymax ) tmp_xfr[i] = ymax;
	}

	for(i = 0; i < 179; i++) {
		if( (i+1)*xstep < 360 ) {
			pDC->MoveTo(x0 + (int)(i*xstep), y0 + 40 - (int)(tmp_xfr[i]));
			pDC->LineTo(x0 + (int)((i+1)*xstep), y0 + 40 - (int)(tmp_xfr[i + 1]));

		}
	}

	pDC->TextOut(x0 - 50, y0 -  28,"Gain [dB]");
	sprintf(gain_char,"%5.1f", gain_range/5.0 + gain_offset);
	pDC->TextOut(x0 - 50, y0 -   8, gain_char);

	if( gain_offset == 0 ) pDC->TextOut(x0 - 30, y0 +  32," 0");

	sprintf(gain_char,"%5.1f", -gain_range/2.0 + gain_offset);
	pDC->TextOut(x0 - 60, y0 + 132, gain_char);
	sprintf(gain_char,"%5.1f", -gain_range + gain_offset);
	pDC->TextOut(x0 - 60, y0 + 225, gain_char);
	
	pDC->TextOut(x0 + 100, y0 - 40,"Gain");
   	pDC->MoveTo(x0 + 140, y0 - 30);
	pDC->LineTo(x0 + 160, y0 - 30);

	pDC->SelectObject(pOldPen);
	myPen.DeleteObject();
}

void CIirFilterView::IirFresCal(double *Xg, double *Xt) {
	int i, k;
	double	omega;
	double	AReal, AImag, AAbs_2;
	double	BReal, BImag, BAbs_2;
	double	HAbs_2;
	double	HdB;
	double	HTheta;

	for(i = 0; i < 360; i++) {
		Xg[i] = 0.0; Xt[i] = 0.0;
		for(k = 0; k < BiquadN; k++) {
			omega = i * Pi / 180.0 + 0.001;

			AReal = 0.0; AImag = 0.0;
			AReal =  a0[k] + a1[k] * cos(1.0 * omega) + a2[k] * cos(2.0 * omega);
			AImag = 0.0 - a1[k] * sin(1.0 * omega) - a2[k] * sin(2.0 * omega);
			AAbs_2 = AReal * AReal + AImag * AImag;

			BReal = 0.0; BImag = 0.0;
			BReal = 1.0 + b1[k] * cos(1.0 * omega) + b2[k] * cos(2.0 * omega);
			BImag = 0.0 - b1[k] * sin(1.0 * omega) - b2[k] * sin(2.0 * omega);
			BAbs_2 = BReal * BReal + BImag * BImag;

			HAbs_2 = AAbs_2 / BAbs_2;
			HdB = 10 * log10(HAbs_2);
			HTheta = 
				atan((AImag*BReal - AReal*BImag) / (AReal*BReal + AImag*BImag)); 
		
			Xg[i] += HdB;
			Xt[i] += HTheta;
		}
	}
}


void CIirFilterView::IirCoeffDraw(CDC *pDC, int x0, int y0)
{
	char tmp_char[20];
	int i, lower, lefter;

	for (i = 0; i < 8; i++) {
			if( i < 4 ) {
				lower = 0, lefter = 0; 
			} else {
				lower = 130; lefter = 640;
			}
			sprintf(tmp_char,"IIR %2d", i + 1);
			pDC->TextOut(x0 + (i)*160 - lefter, y0 - 20 + lower, tmp_char);
			sprintf(tmp_char,"a0 =%13.9f", a0[i]);
			pDC->TextOut(x0 + (i)*160 - lefter, y0 +  0 + lower, tmp_char);
			sprintf(tmp_char,"a1 =%13.9f", a1[i]);
			pDC->TextOut(x0 + (i)*160 - lefter, y0 + 20 + lower, tmp_char);
			sprintf(tmp_char,"a2 =%13.9f", a2[i]);
			pDC->TextOut(x0 + (i)*160 - lefter, y0 + 40 + lower, tmp_char);
			sprintf(tmp_char,"b1 =%13.9f", b1[i]);
			pDC->TextOut(x0 + (i)*160 - lefter, y0 + 60 + lower, tmp_char);
			sprintf(tmp_char,"b2 =%13.9f", b2[i]);
			pDC->TextOut(x0 + (i)*160 - lefter, y0 + 80 + lower, tmp_char);
	}
	pDC->TextOut(x0 + 80, y0 + 250, "BiquadHiQIIRtB^j́iŒjWicڑłB");
}

void CIirFilterView::OnMenuDisp() 
{
	CDlgDisp dlg;

	dlg.m_fres0 = view_select;
	if (dlg.DoModal() == IDOK) {
		view_select = dlg.m_fres0;
		InvalidateRect(NULL, TRUE);
	}	
}

void CIirFilterView::OnMenuRng() 
{
	CDlgRng dlg;

	dlg.m_crng = coeff_range;
	dlg.m_grng = gain_range;
	dlg.m_goffset = gain_offset;
	if (dlg.DoModal() == IDOK) {
		coeff_range = dlg.m_crng; 
		gain_range = dlg.m_grng; 
		gain_offset = dlg.m_goffset; 
		InvalidateRect(NULL, TRUE);
	}	
}

void CIirFilterView::OnMenuFs() 
{
	CDlgFs dlg;

	dlg.m_fs = Fsamp;
	if (dlg.DoModal() == IDOK) {
		Fsamp = dlg.m_fs; 
		freq_range = Fsamp/2; 
		InvalidateRect(NULL, TRUE);
	}	
}

void CIirFilterView::OnMenuCold() 
{
	CFileDialog dlgF(TRUE, NULL, filecoeffld);
	//1FOPEN̂ƂTRUE
	//2,3Ft@C̎
	FILE *ifp;
	float doubleline;
	int linecount;
	int i;
	int filno;
			
	if( dlgF.DoModal() == IDOK)	{
		filecoeffld = dlgF.GetPathName();
		//filenameɑIt@C̃tpX
		ifp = fopen( filecoeffld, "r" );
		//ȍ~Ƀt@Cf[^ǂݍ
		if (ifp != NULL) {
			fseek( ifp, 0L, SEEK_SET );
			for (i = 0; i < 8; i++) {
				a0[i] = 1.0;	a1[i] = 0.0;	a2[i] = 0.0;
				b1[i] = 0.0;	b2[i] = 0.0;
			}
			linecount = 0;
			while( fscanf(ifp, "%f", &doubleline) != EOF ) {
				filno = linecount / 5;
				if(linecount%5==0) a0[filno] = doubleline;
				if(linecount%5==1) a1[filno] = doubleline;
				if(linecount%5==2) a2[filno] = doubleline;
				if(linecount%5==3) b1[filno] = doubleline;
				if(linecount%5==4) b2[filno] = doubleline;
				linecount++;
				if( linecount == 40 ) {
					break;
				}
			}
			BiquadN = filno+1;
			fclose( ifp );
		}
		coeff_loaded = TRUE;
		InvalidateRect(NULL, TRUE);
	}
}

void CIirFilterView::OnMenuWvld() 
{
	GetWavInfo();
	InvalidateRect(NULL, TRUE);	
}

void CIirFilterView::GetWavInfo()
{
	unsigned long len;
	unsigned char s[10];
	int i;
	long fmtbytes;
	FILE *ifp;
	CString filenameld;
	CFileDialog dlgF(TRUE, "NULL", "*.wav");

	if( dlgF.DoModal() == IDOK)	{
		filenameld = dlgF.GetPathName();
		ifp = fopen( filenameld, "rb" );
		if (ifp != NULL) {
			fread(s, 4, 1, ifp); // "RIFF" 
			bytesinfile = get_ulong(ifp); // total bytes in the file
			fread(s, 8, 1, ifp); // "WAVEfmt" 
			fmtbytes = get_ulong(ifp); // header size
			len = get_ushort(ifp); // 1: pcm
			mono1_stereo2 = get_ushort(ifp); // 1: mono, 2; stereo
			samplingfreq = get_ulong(ifp); // sampling frequency
			Fsamp = (double)samplingfreq;
			freq_range = Fsamp/2;
			bytes_per_sec = get_ulong(ifp); // bytes per second
			chbytes_per_sample = get_ushort(ifp); // channels * bytes per sample
			bitlength = get_ushort(ifp); // bit length
			if( bitlength == 16 ) yrng = 10000; else yrng = 100;
			xstart = 0;
			for (i = 0; i < (fmtbytes-16)/2; i++ ) {
				len = get_ushort(ifp); // skip redundant header information
			}
			do{ // look for "data" chunk
				fread(s, 4, 1, ifp); // expect "data"
				if(((s[0] == 'd')&(s[1] == 'a')&(s[2] == 't')&(s[3] == 'a')) == 0){ // step over chunks unless it's "data" chunk
					len = get_ulong(ifp);
					fseek(ifp, len, SEEK_CUR);
				}else{
					break ;
				}
			} while(1);
			totalbytes = get_ulong(ifp); // total bytes of wav data
			bytes_per_sample = bitlength / 8;
			wavesize = totalbytes / (mono1_stereo2 * bytes_per_sample);
			timelength = (double)wavesize/Fsamp;
			int i, m;
			short x;
			AllocateMemory();
			if (mono1_stereo2 == 1) {
				for (i = 0; i < wavesize; i++) { // read mono wav data
					if (fread(s, bytes_per_sample, 1, ifp) != 1) break;
					if (bytes_per_sample == 2) x = (short)(s[0] + 256 * s[1]);
					else x = (short)(s[0]) - 128;
					InWave[i] = (double)(x);
				}
			} else {
				for (i = 0; i < wavesize * 2; i++) { // read stereo wav data
					m = i / 2;
					if (fread(s, bytes_per_sample, 1, ifp) != 1) break;
					if (bytes_per_sample == 2) x = (short)(s[0] + 256 * s[1]);
					else x = (short)(s[0]) - 128;
					if(i%2==0) InWave[m] = (double)(x);
					else InWaveR[m] = (double)(x);
				}
			}
			wave_loaded = TRUE;
			fclose( ifp );
		}
	}
}

void CIirFilterView::AllocateMemory()
{
	if( allocated ) {
		free(InWave);
		free(InWaveR);
	}
	InWave = (double *)calloc(wavesize, sizeof(double));
	InWaveR = (double *)calloc(wavesize, sizeof(double));
	allocated = TRUE;
}

unsigned long CIirFilterView::get_ulong(FILE *f)
{
    unsigned char s[4];
	unsigned res;

    if (fread(s, 4, 1, f) != 1) {
		res = 0;
    } else {
		res = s[0] + 256LU * (s[1] + 256LU * (s[2] + 256LU * s[3]));
	}
    return res;
}

unsigned CIirFilterView::get_ushort(FILE *f)
{
    unsigned char s[2];
	unsigned res;

    if (fread(s, 2, 1, f) != 1) {
		res = 0;
    } else {
		res = s[0] + 256U * s[1];
	}
    return res;
}

unsigned CIirFilterView::get_ubyte(FILE *f)
{
    unsigned char s[1];
	unsigned res;

    if (fread(s, 1, 1, f) != 1) {
		res = 0;
    } else {
		res = s[0];
	}
    return res;
}


void CIirFilterView::WaveDraw(CDC *pDC, int x1, int y1, double *InW)
{
	CPen	myPen;
	CPen*	pOldPen;

	int i;
	int ytmp;
	char tmpchar[12];
	int xscale = 500;
	int yscale = 100;

	sprintf(tmpchar,"%7d", yrng);
	pDC->TextOut( x1 - 55, y1 - yscale - 8, tmpchar);
	sprintf(tmpchar,"%6d", -yrng);
	pDC->TextOut( x1 - 55, y1 + yscale - 8, tmpchar);
	pDC->TextOut( x1 - 20, y1 - 8, "0");

	sprintf(tmpchar,"%7.4f", (double)(dotn/2)/Fsamp);
	pDC->TextOut( x1 + xscale/2 - 30, y1 + yscale + 8, tmpchar);
	sprintf(tmpchar,"%7.4f", (double)dotn/Fsamp);
	pDC->TextOut( x1 + xscale - 30, y1 + yscale + 8, tmpchar);

	myPen.CreatePen(PS_DOT, 1, RGB(0,255,0));
	pOldPen = pDC->SelectObject(&myPen);

	pDC->MoveTo(x1, y1);
	pDC->LineTo(x1 + xscale, y1);

	pDC->MoveTo(x1, y1 - yscale);
	pDC->LineTo(x1 + xscale, y1 - yscale);

	pDC->MoveTo(x1, y1 + yscale);
	pDC->LineTo(x1 + xscale, y1 + yscale);

	pDC->MoveTo(x1, y1 - yscale);
	pDC->LineTo(x1, y1 + yscale);
	pDC->MoveTo(x1 + xscale * 1 / 4, y1 - yscale);
	pDC->LineTo(x1 + xscale * 1 / 4, y1 + yscale);
	pDC->MoveTo(x1 + xscale * 2 / 4, y1 - yscale);
	pDC->LineTo(x1 + xscale * 2 / 4, y1 + yscale);
	pDC->MoveTo(x1 + xscale * 3 / 4, y1 - yscale);
	pDC->LineTo(x1 + xscale * 3 / 4, y1 + yscale);
	pDC->MoveTo(x1 + xscale, y1 - yscale);
	pDC->LineTo(x1 + xscale, y1 + yscale);

	pDC->SelectObject(pOldPen);
	myPen.DeleteObject();

	myPen.CreatePen(PS_SOLID, 1, RGB(0,0,255));
	pOldPen = pDC->SelectObject(&myPen);

	int startint = (int)(xstart/100.0 * wavesize);
	for(i = 0; i < dotn-1; i++) {
		ytmp = (int)(-yscale * InW[startint+i+0] / yrng);
		if( ytmp > yscale ) ytmp = yscale;
		if( ytmp < -yscale ) ytmp = -yscale;
		pDC->MoveTo(x1 + (i+0) * xstep, y1 + ytmp);
		ytmp = (int)(-yscale * InW[startint+i+1] / yrng);
		if( ytmp > yscale ) ytmp = yscale;
		if( ytmp < -yscale ) ytmp = -yscale;
		pDC->LineTo(x1 + (i+1) * xstep, y1 + ytmp);
	}
	pDC->SelectObject(pOldPen);
	myPen.DeleteObject();
}

void CIirFilterView::AllocateMemory2()
{
	if( allocated2 ) {
		free(OutWave);
		free(OutWaveR);
	}
	OutWave = (double *)calloc(wavesize + 1000, sizeof(double));
	OutWaveR = (double *)calloc(wavesize + 1000, sizeof(double));
	allocated2 = TRUE;
}


void CIirFilterView::IirOutWaveCal() {
	int i, filn;
	double *tmpin;
	tmpin = (double *)calloc(wavesize, sizeof(double));
	double *tmpout;
	tmpout = (double *)calloc(wavesize, sizeof(double));
	double *tmpinR;
	tmpinR = (double *)calloc(wavesize, sizeof(double));
	double *tmpoutR;
	tmpoutR = (double *)calloc(wavesize, sizeof(double));

	AllocateMemory2();
	for( i = 0; i < wavesize; i++ ) {
		OutWave[i] = 0.0; OutWaveR[i] = 0.0;
	}

	double k2 = 1.0;
	for ( i = 0; i < bitlength - 1; i++ ) { // for sign bit
		k2 = k2 * 2.0;
	}
	k2 = k2 - 1.0;  // k2 = 128 at 8 bits
	for( filn = 0; filn < BiquadN; filn++ ) {
		for(i = 0; i < wavesize; i++) {
			if(filn == 0) {
				tmpin[i] = InWave[i]; tmpinR[i] = InWaveR[i]; 
				tmpout[i] = 0.0; tmpoutR[i] = 0.0;
			} else {
				tmpin[i] = tmpout[i]; tmpinR[i] = tmpoutR[i]; 
				tmpout[i] = 0.0; tmpoutR[i] = 0.0;
			}
		}
		for(i = 2; i < wavesize; i++) {
			tmpout[i] = a2[filn] * tmpin[i-2] 
					+ a1[filn] * tmpin[i-1] 
					+ a0[filn] * tmpin[i-0]
					- b2[filn] * tmpout[i-2] 
					- b1[filn] * tmpout[i-1];
			tmpoutR[i] = a2[filn] * tmpinR[i-2] 
					+ a1[filn] * tmpinR[i-1] 
					+ a0[filn] * tmpinR[i-0]
					- b2[filn] * tmpoutR[i-2] 
					- b1[filn] * tmpoutR[i-1];
		}
	}
	for(i = 0; i < wavesize; i++) {
		if(tmpout[i] > k2) tmpout[i] = k2;	 if(tmpout[i] < -k2) tmpout[i] = -k2;
		if(tmpoutR[i] > k2) tmpoutR[i] = k2; if(tmpoutR[i] < -k2) tmpoutR[i] = -k2;
		OutWave[i] = tmpout[i]; OutWaveR[i] = tmpoutR[i];
	}
	free( tmpin ); free( tmpout );
	free( tmpinR ); free( tmpoutR );
}

void CIirFilterView::OnMenuWvsv() 
{
	if(wave_loaded == TRUE) PutWavInfo();
	else { 
		CString strtmp;
		strtmp = "uWavet@CvuWaveݍ݁vIĂB";
		AfxMessageBox(strtmp,MB_OK|MB_ICONEXCLAMATION);
	}
	InvalidateRect(NULL, TRUE);		
}

void CIirFilterView::PutWavInfo()
{
	char s[10];
	int numwritten;
	int i, m;
	FILE *ifp;
	CString filenamesv;
	CFileDialog dlgF(FALSE, "NULL", "test1.wav");

	if( dlgF.DoModal() == IDOK)	{
		filenamesv = dlgF.GetPathName();
		ifp = fopen( filenamesv, "wb" );
		if (ifp != NULL) { // 
			sprintf(s, "RIFF"); 
			numwritten = fwrite( s, 4, 1, ifp );
			put_ulong(bytesinfile, ifp); // total bytes in the file
			sprintf(s, "WAVEfmt "); 
			numwritten = fwrite( s, 8, 1, ifp );
			put_ulong(16, ifp); // 16 bytes -- always
			put_ushort(1, ifp); // 1: pcm
			put_ushort(mono1_stereo2, ifp); // 1: mono, 2; stereo
			put_ulong(samplingfreq, ifp); // sampling frequency	
			put_ulong(bytes_per_sec, ifp); // bytes per second
			put_ushort(chbytes_per_sample, ifp); // channels * bytes per sample
			put_ushort(bitlength, ifp); // bit length
			sprintf(s, "datafmt "); 
			numwritten = fwrite( s, 4, 1, ifp );
			put_ulong(totalbytes, ifp); // total bytes of wav data
			if (mono1_stereo2 == 1) {
				for (i = 0; i < wavesize; i++) { // write mono wav data
					if (bytes_per_sample == 2) 
						put_ushort((short)OutWave[i], ifp);
					else 
						put_ubyte((short)OutWave[i], ifp);
				}
			} else {
				for (i = 0; i < wavesize * 2; i++) { // write stereo wav data 
					m = i / 2;
					if (bytes_per_sample == 2) 
						if(i%2==0) put_ushort((short)OutWave[m], ifp);
						else put_ushort((short)OutWaveR[m], ifp);
					else
						if(i%2==0) put_ubyte((short)OutWave[m], ifp);
						else put_ubyte((short)OutWaveR[m], ifp);
				}
			}
			fclose( ifp );
		} else { 
			CDlgWrErr dlg;
			if (dlg.DoModal() == IDOK) {
			}
		}
	}
}

void CIirFilterView::put_ulong(long x, FILE *f)
{
    unsigned char s[4];
	long divident;
	int numwritten;

	s[3] = (unsigned char)(x / 256LU / 256LU / 256LU);
	divident = x - s[3] * 256LU * 256LU * 256LU;
	s[2] = (unsigned char)(divident / 256LU / 256LU);
	divident = x - s[3] * 256LU * 256LU * 256LU - s[2] * 256LU * 256LU;
	s[1] = (unsigned char)(divident / 256LU);
	s[0] = (unsigned char)(x - s[3] * 256LU * 256LU * 256LU 
			- s[2] * 256LU * 256LU - s[1] * 256LU);

	numwritten = fwrite( s, 4, 1, f );
}

void CIirFilterView::put_ushort(short x, FILE *f)
{
    unsigned char s[2];
	int numwritten;

	s[1] = (unsigned char)(x / 256LU);
	s[0] = (unsigned char)(x - s[1] * 256LU);

	numwritten = fwrite( s, 2, 1, f );
}

void CIirFilterView::put_ubyte(short x, FILE *f)
{
    unsigned char s[1];
	int numwritten;

	s[0] = (unsigned char)(x + 128);

	numwritten = fwrite( s, 1, 1, f );
}

void CIirFilterView::OnPrint(CDC* pDC, CPrintInfo* pInfo) 
{
	CRect rectClient;
	GetClientRect(&rectClient);
	pDC -> SetMapMode(MM_ANISOTROPIC);
	pDC -> SetWindowOrg(0,0);
	pDC -> SetWindowExt(100,50);
	pDC -> SetViewportOrg(0,0);
	pDC -> SetViewportExt(550, 350); // `TCYݒ

	CFont* pfontCurrent = pDC -> GetCurrentFont();
	LOGFONT lfCurrentFont;
	pfontCurrent -> GetObject(sizeof(LOGFONT), &lfCurrentFont);
	CFont fontBig;
	lfCurrentFont.lfHeight = 12; // tHgTCYijݒ
	lfCurrentFont.lfWidth = 6; // tHgTCYijݒ

	fontBig.CreateFontIndirect(&lfCurrentFont);
	CFont* defaultFont = (CFont*)pDC -> SelectObject(&fontBig);

	CView::OnPrint(pDC, pInfo);
}
